//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header: fsfreefile.c,r42 2006-02-18 04:23:47 ingo $


#include "fsyspriv.h"


// CLEANUP FS_FILE STRUCTURES
FS_FILE *FSFreeFile(FS_FILE *file)
{
FS_FILE *orig=file->Dir;
FS_VOLUME *fs;

if(file==NULL) {
//printf("Trying to Free() NULL\n");
return NULL;
}

if(file->Volume&(~3)) {
//printf("Invalid volume at free()\n");
return NULL;
}

// CHECK FOR REFERENCES BEFORE DELETING
fs=FSystem.Volumes[file->Volume];

if(!fs) return NULL;

if(FSFileIsReferenced(file,fs)) return NULL;

// NOT REFERENCED
// IT'S SAFE TO DELETE THIS FILE OBJECT

// FREE ENTIRE CLUSTER CHAIN
//printf("fffree cluster chain\n");
FSFreeChain(file);

// FREE READ/WRITE BUFFERS

if(file->RdBuffer.Data) free(file->RdBuffer.Data);
if(file->WrBuffer.Data) free(file->WrBuffer.Data);


//printf("done\n");
// FREE NAME
if(file->Name) free(file->Name);
//printf("done free name\n");
// FREE FS_FILE
free(file);
//printf("done free file\n");
return orig;
}
