//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: sat3.h 424 2007-04-01 15:24:34Z claudio $


#include <hpgcc3.h>
#include <system_globals.h>

void __keyb_waitrelease();
int __keyb_getkey(int wait);



void __ex_print(int *scrbuf,int x,int y,char *str)
{
void *minif=get_minifont();

int cdatalow,cdatahigh;
char *scrptr;
int offset,rot,rotx;
char mask;
int f;


while(*str) {
scrptr=(char *)scrbuf;
// POINT TO START OF LINE
scrptr+=y*6*20;
scrptr+=x>>1;
rotx=x&1;
mask=(rotx)? 0xf0:0x0f;

// CALC OFFSET IN NIBBLES
offset=(*str)*6+7;
// OFFSET IN NIBBLES
rot=offset&7;
// WORD WITH THE START OF CHAR
offset&=0xfffffff8;
// READ THE DATA CHARACTER
cdatalow=*(int *)(minif+(offset>>1));
cdatahigh=*(int *)(minif+4+(offset>>1));

// PUT DATA IN POSITION
while(rot<rotx)
{
cdatahigh= (cdatahigh<<4) | (cdatalow>>28);
cdatalow<<=4;

++rot;
}

while(rot>rotx) {
cdatalow= (cdatalow>>4) | (cdatahigh<<28);
cdatahigh>>=4;
--rot;
}

for(f=0;f<6;++f)
{
    *scrptr= ((*scrptr)&(mask^0xff))|(cdatalow&mask);
    scrptr+=20;
    cdatalow= (cdatalow>>4) | (cdatahigh<<28);
    cdatahigh>>=4;
}

++str;
++x;
if(x>32) {
y++;
x=0;	
}
}

}

void __ex_hline(int *scrbuf,int y)
{
memsetw(scrbuf+5*y,0xaaaaaaaa,5);
}


// GET HIGH REGISTERS R8 TO R14 + CPSR (8 WORDS)

void __ex_gethireg(unsigned int *hi_reg)
{
register unsigned int tmp asm ("r3");
register unsigned int tmp2 asm ("r2");

asm volatile ("mrs %0,cpsr" : "=r" (tmp));
asm volatile ("mrs %0,spsr" : "=r" (tmp2));
asm volatile ("bic %0,%1,#0x1f" : "=r" (tmp) : "r" (tmp));		// CLEAN STATE BITS
asm volatile ("and %0,%1,#0x1f" : "=r" (tmp2) : "r" (tmp2));	// ISOLATE ORIGINAL STATUS
asm volatile ("orr %0,%1,%2" : "=r" (tmp) : "r" (tmp), "r" (tmp2) );		// APPLY ORIGINAL STATUS
asm volatile ("cmp %0,#0x10" : "=r" (tmp2));					// CHECK FOR USER MODE
asm volatile ("orreq %0,%1,#0x1f" : "=r" (tmp) : "r" (tmp) );	// IF USER MODE, SWITCH TO SYSTEM MODE
asm volatile ("mrs %0,cpsr" : "=r" (tmp2));
asm volatile ("msr cpsr,%0" : "=r" (tmp));
asm volatile ("stmia r0,{r8,r9,r10,r11,r12,r13,r14}");
asm volatile ("msr cpsr,%0" : "=r" (tmp2));

asm volatile ("mrs %0,spsr" : "=r" (tmp));

hi_reg[7]=tmp;
	
return;	
}



// MAIN EXCEPTION PROCESSOR

#define __EX_CONT 1		// SHOW CONTINUE OPTION
#define __EX_EXIT 2		// SHOW EXIT OPTION
#define __EX_WARM 4		// SHOW WARMSTART OPTION
#define __EX_RESET 8	// SHOW RESET OPTION
#define __EX_NOREG 16	// DON'T SHOW REGISTERS

int __exception_handler(char *exstr, unsigned int *registers,int options)
{
unsigned int lcd_buffer[17];
unsigned int hi_reg[8];
char a[10];

int f,j;

int *pnewb=(int *)((sys_map_v2p((unsigned int) &(__sg->exception_screen))+0xf)&(~0xf));

lcd_save(lcd_buffer);
lcd_setmode(0,pnewb);

memsetw(pnewb,0,425);

if(options&__EX_NOREG) {

	__ex_print(pnewb,9,2,"-- EXCEPTION --");
	__ex_hline(pnewb,8);
	__ex_hline(pnewb,20);
	
	__ex_print(pnewb,16-(strlen(exstr)>>1),5,exstr);


}
else {
	__ex_print(pnewb,0,0,"Exception: ");
	__ex_print(pnewb,11,0,exstr);
	a[2]=0;
	for(f=0;f<8;++f) {
	__ex_print(pnewb,0,f+2,"R :");
	a[1]=0;
	a[0]=f+48;
	__ex_print(pnewb,1,f+2,a);
	__ex_print(pnewb,12,f+2,"R  :");
	if(f<2) a[0]=f+8+48;
	else { a[0]='1'; a[1]=f-2+48; }
	__ex_print(pnewb,13,f+2,a);
	}
	
	__ex_hline(pnewb,8);
	
	a[8]=0;
	
	// DISPLAY REGISTERS
	
	for(f=0;f<8;++f)
	{
		for(j=7;j>=0;j--)
		{
		a[7-j]=((registers[f+1]>>(j<<2))&0xf)+48;
		if(a[7-j]>'9') a[7-j]+=7;
		}
		__ex_print(pnewb,3,f+2,a);
		
	}


	// DISPLAY BANKED REGISTERS
	// GET BANKED REGISTERS	
	__ex_gethireg(hi_reg);
	
	for(f=0;f<7;++f)
	{

		for(j=7;j>=0;j--)
		{
		a[7-j]=((hi_reg[f]>>(j<<2))&0xf)+48;
		if(a[7-j]>'9') a[7-j]+=7;
		}
		__ex_print(pnewb,16,f+2,a);
	
	}

		// PC
		for(j=7;j>=0;j--)
		{
		a[7-j]=((registers[0]>>(j<<2))&0xf)+48;
		if(a[7-j]>'9') a[7-j]+=7;
		}
		__ex_print(pnewb,16,9,a);
		
		// FLAGS
		if(hi_reg[7]&0x80000000) { __ex_print(pnewb,31,2,"N");  __ex_print(pnewb,28,2,"MI");} else __ex_print(pnewb,28,2,"PL");
		if(hi_reg[7]&0x40000000) { __ex_print(pnewb,31,3,"Z"); __ex_print(pnewb,28,3,"EQ"); } else __ex_print(pnewb,28,3,"NE");
		if(hi_reg[7]&0x20000000) { __ex_print(pnewb,31,4,"C"); __ex_print(pnewb,28,4,"CS"); } else __ex_print(pnewb,28,4,"CC");
		if(hi_reg[7]&0x10000000) { __ex_print(pnewb,31,5,"V");  __ex_print(pnewb,28,5,"VS");} else __ex_print(pnewb,28,5,"VC");
		if( (hi_reg[7]&0x60000000)==0x20000000) { __ex_print(pnewb,28,5,"HI"); } else __ex_print(pnewb,28,5,"LS");
		if(  (hi_reg[7] ^ (hi_reg[7]>>3) )&0x10000000) { 
			__ex_print(pnewb,28,6,"LT"); 
			}
		else { if(!(hi_reg[7]&0x40000000)) __ex_print(pnewb,28,6,"GT"); }
		
		if((hi_reg[7]&0x40)) {
		__ex_print(pnewb,27,7,"F" );
		}
		if((hi_reg[7]&0x80)) {
		__ex_print(pnewb,31,7,"I" );
		}
		
		
		if((hi_reg[7]&0x1f)==0x10) {
		__ex_print(pnewb,27,8,"USER" );
		}
		if((hi_reg[7]&0x1f)==0x11) {
		__ex_print(pnewb,27,8,"FIQ" );
		for(f=0;f<7;++f)
		{
		__ex_print(pnewb,24,f+2,"/B" );
		}
		}
		if((hi_reg[7]&0x1f)==0x12) {
		__ex_print(pnewb,27,8,"IRQ" );
		for(f=5;f<7;++f)
		{
		__ex_print(pnewb,24,f+2,"/B" );
		}
		}
		if((hi_reg[7]&0x1f)==0x13) {
		__ex_print(pnewb,27,8,"SUP" );
		for(f=5;f<7;++f)
		{
		__ex_print(pnewb,24,f+2,"/B" );
		}
		}
		if((hi_reg[7]&0x1f)==0x17) {
		__ex_print(pnewb,27,8,"ABT" );
		for(f=5;f<7;++f)
		{
		__ex_print(pnewb,24,f+2,"/B" );
		}
		}
		if((hi_reg[7]&0x1f)==0x1B) {
		__ex_print(pnewb,27,8,"UND" );
		for(f=5;f<7;++f)
		{
		__ex_print(pnewb,24,f+2,"/B" );
		}
		}
		if((hi_reg[7]&0x1f)==0x1f) {
		__ex_print(pnewb,27,8,"SYS" );
		}


		if(hi_reg[7]&0x20) __ex_print(pnewb,27,9,"Thumb"); else  __ex_print(pnewb,28,9,"ARM");
		
		__ex_hline(pnewb,62);
		
}

if(options&__EX_CONT) {
		// DRAW BUTTON 1
		__ex_print(pnewb,0,12,"Cont");
		//pnewb[70*5]|=0x10000;
		for(f=0;f<8;++f) pnewb[71*5+5*f]|=0x20000;
		pnewb[78*5]|=0x3ffff;
		pnewb[79*5]|=0x3fffc;
}

if(options&__EX_EXIT) {
		// DRAW BUTTON 2
		__ex_print(pnewb,5,12,"Exit");
		for(f=0;f<8;++f) pnewb[71*5+1+5*f]|=0x20;
		pnewb[78*5]|=0xfff80000;
		pnewb[78*5+1]|=0x3f;
		pnewb[79*5]|=0xffe00000;
		pnewb[79*5+1]|=0x3f;
}

if(options&__EX_WARM) {
		// DRAW BUTTON 3
		__ex_print(pnewb,11,12,"*Warmstart*");
		for(f=0;f<8;++f) pnewb[71*5+2+5*f]|=0x2000000;
		pnewb[78*5+2]|=0x3ffffff;
		pnewb[78*5+1]|=0xfffff000;
		pnewb[79*5+2]|=0x3ffffff;
		pnewb[79*5+1]|=0xffffc000;
}

if(options&__EX_RESET) {
		// DRAW BUTTON 4
		__ex_print(pnewb,23,12,"**Reset**");
		for(f=0;f<9;++f) pnewb[71*5+4+5*f]|=0x1;
		pnewb[78*5+3]|=0xffffffff;
		pnewb[78*5+2]|=0xf0000000;
		pnewb[79*5+3]|=0xffffffff;
		pnewb[79*5+2]|=0xc0000000;
}
		
// WARMSTART AND RESET REQUIRE SIMULTANEOUS SHIFT OR ALPHA KEYPRESS

// WAIT FOR ALL KEYS TO BE RELEASED TO AVOID ACCIDENTAL KEYPRESSES

__keyb_waitrelease();


do {
f=__keyb_getkey(1);

if(options&__EX_CONT) {
j=__EX_CONT;
if( KEYCODE(f)==KB_A )	break;
}
if(options&__EX_EXIT) {
j=__EX_EXIT;
if( KEYCODE(f)==KB_B )	break;
}

// FORCE A SHIFTED KEY PRESS
if(!SHIFTPLANE(f)) continue;


if(options&__EX_WARM) {
j=__EX_WARM;
if( KEYCODE(f)==KB_C )	break;
if( KEYCODE(f)==KB_D )	break;
}

if(options&__EX_RESET) {
j=__EX_RESET;
if( KEYCODE(f)==KB_E )	break;
if( KEYCODE(f)==KB_F )	break;
}
} while(1);

lcd_restore(lcd_buffer);

return j;

}


void __handler_dabort(void) __attribute__ ((naked));
void __handler_dabort(void)
{
	// STORE ALL REGISTERS INTO THE SAFE STACK
    asm volatile ("stmfd sp!, {r0-r12, r14}");
    asm volatile ("mrs r0,cpsr");
    asm volatile ("orr r0,r0,#0xc0");			// DISABLE ALL FIQ AND IRQ INTERRUPTS
    asm volatile ("msr cpsr,r0");

    asm volatile ("sub r14,r14,#8");			// CHANGE FOR ALL DIFFERENT EXCEPTIONS TO POINT TO THE RIGHT PC
    asm volatile ("str r14,[sp,#-4]!");

	register unsigned int *stackptr asm("sp");
	// CALL CUSTOM HANDLER
	register int f=__exception_handler("Data abort",stackptr,__EX_CONT | __EX_EXIT | __EX_WARM | __EX_RESET);

	if(f==__EX_CONT) {
	// RESTORE ALL REGISTERS
	asm volatile ("add sp,sp,#4");
    asm volatile ("ldmfd sp!, {r0-r12, r14}");

	// RETURN TO THE NEXT INSTRUCTION AFTER DATA FAILED (DON'T RETRY)
    asm volatile ("subs pc, r14,#4");
    
	}
	
	asm volatile (".Ldohandlerexit:");

	if(f==__EX_EXIT) {
		
	asm volatile ("ldr lr, .Lexit");
	asm volatile ("b .Lretexit");
    
	}

	if(f==__EX_WARM) {
	asm volatile ("ldr lr, .Lexitwarm");
	asm volatile ("b .Lretexit");
	}

	// DEFAULT = EXIT W/RESET

	asm volatile ("ldr lr, .Lexitreset");

	asm volatile (".Lretexit:");
	
	register unsigned int tmp asm ("r0"),tmp1 asm("r1");

	asm volatile ("mrs %0,spsr" : "=r" (tmp));
	asm volatile ("bic %0,%1,#0xff" : "=r" (tmp) : "r" (tmp));		// CLEAN STATE BITS
	asm volatile ("orr %0,%1, #0x10" : "=r" (tmp) : "r" (tmp));		// SET USER CPU MODE W/IRQ AND FIQ ENABLED, ARM MODE
	asm volatile ("msr spsr,%0" : "=r" (tmp));						// SAVE USER MODE STATUS
	asm volatile ("mov %0,#0x07100000" : "=r" (tmp));
	asm volatile ("mvn %0,#0" : "=r" (tmp1));
	asm volatile ("str %0,[%1,#8]" : "=r" (tmp1) : "r" (tmp));		// MASK ALL INTERRUPTS BEFORE RETURNING
	asm volatile ("str %0,[%1]" : "=r" (tmp1) : "r" (tmp));		// CLEAR ALL PENDING INTERRUPTS
	asm volatile ("str %0,[%1,#0x10]" : "=r" (tmp1) : "r" (tmp));		// CLEAR ALL PENDING INTERRUPTS
	
	
	// RESTORE ALL REGISTERS
	asm volatile ("add sp,sp,#4");
    asm volatile ("ldmfd sp!, {r0-r12}");
	asm volatile ("add sp,sp,#4");

    asm volatile ("mov r0,#-1"); 	// EXIT WITH CODE -1
    
	// RETURN DIRECTLY INTO THE exit FUNCTION
    asm volatile ("movs pc, r14");
    
    asm volatile (".Lexit: .word exit");
    asm volatile (".Lexitwarm: .word __exit_warm");
    asm volatile (".Lexitreset: .word __exit_reset");

}




void __handler_iabort(void) __attribute__ ((naked));
void __handler_iabort(void)
{
register unsigned int *stackptr asm("sp");

	// STORE ALL REGISTERS INTO THE SAFE STACK
    asm volatile ("stmfd sp!, {r0-r12, r14}");
    asm volatile ("mrs r0,cpsr");
    asm volatile ("orr r0,r0,#0xc0");			// DISABLE ALL FIQ AND IRQ INTERRUPTS
    asm volatile ("msr cpsr,r0");
    asm volatile ("sub r14,r14,#4");			// CHANGE FOR ALL DIFFERENT EXCEPTIONS TO POINT TO THE RIGHT PC
    asm volatile ("str r14,[sp,#-4]!");

	// CALL CUSTOM HANDLER
	register int f=__exception_handler("Prefetch abort",stackptr,__EX_CONT | __EX_EXIT | __EX_WARM | __EX_RESET);

   	if(f==__EX_CONT) {
	// RESTORE ALL REGISTERS
	asm volatile ("add sp,sp,#4");
    asm volatile ("ldmfd sp!, {r0-r12, r14}");

	// RETURN TO THE NEXT INSTRUCTION AFTER DATA FAILED (DON'T RETRY)
    asm volatile ("movs pc, r14");
    
	}

	asm volatile ("b .Ldohandlerexit");
     
}

void __handler_und(void) __attribute__ ((naked));
void __handler_und(void)
{
register unsigned int *stackptr asm("sp");
register unsigned int value asm("r0");

	// STORE ALL REGISTERS INTO THE SAFE STACK
    asm volatile ("stmfd sp!, {r0-r12, r14}");
    asm volatile ("sub r14,r14,#4");			// CHANGE FOR ALL DIFFERENT EXCEPTIONS TO POINT TO THE RIGHT PC
    asm volatile ("mrs r0,cpsr");
    asm volatile ("orr r0,r0,#0xc0");			// DISABLE ALL FIQ AND IRQ INTERRUPTS
    asm volatile ("msr cpsr,r0");
    asm volatile ("mrs r0,spsr");
    asm volatile ("ands r0,r0,#0x20");
    asm volatile ("add r14,r14,r0,LSR #4");		// ADD 2 IF IN THUMB MODE (PC+2)
    
   
    asm volatile ("str r14,[sp,#-4]!");

    // DO NOT LOAD ANY VALUE IF IN THUMB MODE
    asm volatile ("ldreq %0,[r14]" : "=r" (value) : "r" (value));				// GET OFFENDING INSTRUCTION

	if(value==0xe6cccc10)
	{

	value=__exception_handler((char *) (stackptr[1]),stackptr,stackptr[2] | __EX_NOREG);

	}
	else {
	// CALL CUSTOM HANDLER
	if(value==0xe6dddd10) 	value=__exception_handler((char *) (stackptr[1]),stackptr,stackptr[2]);
 	else
		value=__exception_handler("Undefined instruction",stackptr,__EX_CONT | __EX_EXIT | __EX_WARM | __EX_RESET);
	}
   	if(value==__EX_CONT) {
	// RESTORE ALL REGISTERS
	asm volatile ("add sp,sp,#4");
    asm volatile ("ldmfd sp!, {r0-r12, r14}");

	// RETURN TO THE NEXT INSTRUCTION AFTER DATA FAILED (DON'T RETRY)
    asm volatile ("movs pc, r14");
    
	}
	
	asm volatile ("b .Ldohandlerexit");
	

}


extern void __go_supervisor(unsigned int funcarg,unsigned int __funcaddr,unsigned int SWI_vector);

static void __ex_setstk(void) __attribute__ ((naked));
static void __ex_setstk(void)
{
    // STORE ORIGINAL STACK POINTER IN SPECIAL MODES
	
	// SET STACK AT: FIQ=[128], IRQ=[64], EXCEPTION=[256]
	// STACK OVERFLOW FROM AN IRQ HANDLER WILL SPILL INTO EXCEPTION
	// SCREEN BUFFER. POSSIBLE CRASH IF AN EXCEPTION HAPPENS INSIDE AN IRQ
	// HANDLER THAT CAUSED AN OVERFLOW
	
	asm volatile ("stmfd sp!,{r0,r1,r2,r3}");
	
	
    register unsigned int stkaddr asm ("r1") =(unsigned int) &(__sg->exception_save);

    asm volatile ("mrs r0,cpsr");
    asm volatile ("add r0,r0,#4");
    asm volatile ("msr cpsr,r0");		// ENTER ABORT MODE
    asm volatile ("str sp,[%0,#24]" : "=r" (stkaddr) : "r" (stkaddr));
    asm volatile ("sub sp,%0,#4" : "=r" (stkaddr));
    asm volatile ("add r0,r0,#4");
    
    asm volatile ("msr cpsr,r0");		// ENTER UNDEFINED MODE
    asm volatile ("str sp,[%0,#28]" : "=r" (stkaddr));
    asm volatile ("sub sp,%0,#4" : "=r" (stkaddr));
    asm volatile ("sub r0,r0,#9");

    asm volatile ("msr cpsr,r0");		// ENTER IRQ MODE
    asm volatile ("str sp,[%0,#32]" : "=r" (stkaddr));
    asm volatile ("sub sp,%0,#768" : "=r" (stkaddr));
    asm volatile ("sub r0,r0,#1");

    asm volatile ("msr cpsr,r0");		// ENTER FIQ MODE
    asm volatile ("stmia %0,{r8,r9,r10,r11,r12,r13}" : "=r" (stkaddr));
    asm volatile ("sub sp,%0,#512" : "=r" (stkaddr));
    
    asm volatile ("add r0,r0,#2");
	asm volatile ("msr cpsr,r0");		// ENTER SUPERVISOR MODE

	asm volatile ("ldmfd sp!,{r0,r1,r2,r3}");

    asm volatile ("movs pc, r14");
}

static void __ex_resstk(void) __attribute__ ((naked));
static void __ex_resstk(void)
{
	
	asm volatile ("stmfd sp!,{r0,r1,r2,r3}");

	
    // RESTORE ORIGINAL STACK POINTER IN SPECIAL MODES
    register unsigned int stkaddr asm ("r1") =(unsigned int) &(__sg->exception_save);
    
    asm volatile ("mrs r0,cpsr");
    asm volatile ("add r0,r0,#4");
    asm volatile ("msr cpsr,r0");		// ENTER ABORT MODE
    asm volatile ("ldr sp,[%0,#24]" : "=r" (stkaddr) : "r" (stkaddr));
    asm volatile ("add r0,r0,#4");
    
    asm volatile ("msr cpsr,r0");		// ENTER UNDEFINED MODE
    asm volatile ("ldr sp,[%0,#28]" : "=r" (stkaddr));
    asm volatile ("sub r0,r0,#9");

    asm volatile ("msr cpsr,r0");		// ENTER IRQ MODE
    asm volatile ("ldr sp,[%0,#32]" : "=r" (stkaddr));
    asm volatile ("sub r0,r0,#1");

    asm volatile ("msr cpsr,r0");		// ENTER FIQ MODE
    asm volatile ("ldmia %0,{r8,r9,r10,r11,r12,r13}" : "=r" (stkaddr));
    
    asm volatile ("add r0,r0,#2");
	asm volatile ("msr cpsr,r0");		// ENTER SUPERVISOR MODE
	
	asm volatile ("ldmfd sp!,{r0,r1,r2,r3}");
	
    asm volatile ("movs pc, r14");
}


extern void __irq_install(void);

void __exception_install(unsigned int *org_handler)
{
    unsigned *handler_addr=(unsigned int *)0x08000000L;
	memcpyw(org_handler, handler_addr,8);
	handler_addr[1]=(unsigned int)(&__handler_und);
	handler_addr[3]=(unsigned int)(&__handler_iabort);
	handler_addr[4]=(unsigned int)(&__handler_dabort);
	__irq_install();
		
	__go_supervisor( 0,(unsigned int) &__ex_setstk,0x08000008);
	
}

void __exception_uninst(unsigned int *org_handler)
{
    unsigned int volatile * INTMSK = (unsigned int*) 0x7100008;   
	*INTMSK = 0xffffffff; //mask all interrupts
	
	// RESTORE ORIGINAL EXCEPTION AND IRQ CPU STATE
	__go_supervisor(0, (unsigned int) &__ex_resstk,0x08000008);
	
	// RESTORE ORIGINAL EXCEPTION AND IRQ HANDLERS
    unsigned *handler_addr=(unsigned int *)0x08000000L;
	memcpyw(handler_addr,org_handler,8);
}


 
void throw_exception(char * message, unsigned int options)
{
 asm volatile (".word 0xE6CCCC10");
}

void throw_dbgexception(char * message, unsigned int options)
{
 asm volatile (".word 0xE6DDDD10");
}



