//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***




#include <hpgcc3.h>

// CONVERT AN EXTENDED REAL TO BASE-10 FORMAT

void xr_base10(XREAL *base2,XREAL *res)
{
XREAL x10;
int exp2,exp10;

exp2=base2->Exp;

exp10=(int) (((long long)abs(exp2)*LN2_LN10)>>32);

xr_10pow(exp10,&x10);

if(exp2>=0) xr_div(base2,&x10,&x10);
else { xr_mul(base2,&x10,&x10); exp10=-exp10; }


if(x10.Exp>0) {
// ROUNDING ERROR, SHIFT 1 DIGIT
XREAL temp;
xr_10pow(1,&temp);
xr_div(&x10,&temp,&x10);
exp10++;
}




exp2=-x10.Exp;

if(exp2) {
	// ROUND LAST BIT
	if(exp2>=3) {
	// MAY BE MISING BY ONE DIGIT
	if((x10.Mant>>3)<0x1999999999999999LL) { x10.Mant+=(x10.Mant+2)>>2; --exp10; exp2-=3;}
	}
	if(exp2) x10.Mant+=1LL<<(exp2-1);
	x10.Mant>>=exp2;
}


res->Exp=exp10;
res->Sign=base2->Sign;
res->Mant=x10.Mant;
return;
}
