//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***




#include <hpgcc3.h>

// CONVERT AN EXTENDED REAL TO DOUBLE

double xr_xr2double(XREAL *num)
{
	union {
		double a;
		unsigned long long ul;
		struct { unsigned int lo,hi; } w32;
	} dbl;
	unsigned int sign=0;
	unsigned long long mant=num->Mant;
	int exponent=num->Exp;

	if(exponent<-1138 || mant==0LL) return 0.0;
	if(exponent<-1086) {
	// SUBNORMAL NUMBER
	mant>>=-1086-exponent;
	exponent=-1086;
	}
	if(exponent>960) {
		if(exponent!=0x20000000) {
		// RETURN	INF/NAN
		mant=0;
		}
		exponent=961;

	}


	if(num->Sign) sign=0x800;
	dbl.ul=((mant<<1)+0x800)>>12;
	dbl.ul|=((unsigned long long)(((exponent+1023+63)&0x7ff)|sign))<<52;
	
	// WORKAROUND FOR THE BIG-ENDIAN DOUBLE REPRESENTATION IN GCC
	sign=dbl.w32.lo;
	dbl.w32.lo=dbl.w32.hi;
	dbl.w32.hi=sign;

	return dbl.a;

}
