//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


#include <keyb.h>

extern unsigned int __cpu_intoff();
extern void __cpu_inton(unsigned int);



#define DEBOUNCE  16  // 10 SEEMS TO BE ADEQUATE EVEN AT 75 MHz

// TURNED INTO A LOW-LEVEL ROUTINE TO BE USED BY THE IRQ HANDLERS AND EXCEPTION
// HANDLERS ONLY

keymatrix __keyb_getmatrix()
{


    unsigned int volatile * GPGDAT = (unsigned int*) 0x7A00064; //data
    unsigned int volatile * GPGCON = (unsigned int*) 0x7A00060; //control

    unsigned int tmp[DEBOUNCE],f;


    unsigned int lo=0,hi=0;

    int col;
    unsigned int control;

    for(col=7;col>=4;--col)
    {
    
    control = 1<<((col+8)*2); //set the correct col pin to output, others inputs
    control = control | 0xAAA9; //fix up the lower bits
    *GPGCON = control; // write the new control value.


	// DEBOUNCE TECHNIQUE
	do {
	for(f=0;f<DEBOUNCE;++f) tmp[f]=*GPGDAT;
	
	for(f=1;f<DEBOUNCE;++f) {
		if(tmp[f]!=tmp[f-1]) break;
	}
	} while(f<DEBOUNCE);


    hi=(hi<<8) | ((~(tmp[0]))&0xfe);

    }

    for(;col>=0;--col)
    {
    
    control = 1<<((col+8)*2); //set the correct col pin to output, others inputs
    control = control | 0xAAA9; //fix up the lower bits
    *GPGCON = control; // write the new control value.

	// DEBOUNCE TECHNIQUE
	do {
	for(f=0;f<DEBOUNCE;++f) tmp[f]=*GPGDAT;
	
	for(f=1;f<DEBOUNCE;++f) {
		if(tmp[f]!=tmp[f-1]) break;
	}
	} while(f<DEBOUNCE);
	
	
    lo=(lo<<8) | ((~(tmp[0]))&0xfe);

    }

    *GPGCON = 0x5555AAA9; //restore default

    unsigned int volatile GPFDAT = *((int*) 0x7A00054);

    hi |=  (GPFDAT&0x70)<<24;
    hi |=  GPFDAT<<31;

    return ((keymatrix)lo) | (((keymatrix)hi)<<32);
}


// WRAPPER TO DISABLE INTERRUPTS WHILE READING THE KEYBOARD
// NEEDED ONLY WHEN CALLED FROM WITHIN AN EXCEPTION HANDLER



keymatrix __keyb_getmatrixEX()
{
	unsigned int saved=__cpu_intoff();
	keymatrix m=__keyb_getmatrix();
	__cpu_inton(saved);
	return m;
}
