//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: sat3_hxs.c 511 2007-11-13 01:42:01Z claudio $

#include <hpgcc3.h>
#include <master_globals.h>

// CREATE A 32-BIT HXS VALUE

#define sat3_createhxs_uint(where,value) sat3_createhxs_int(where,value)
#define sat3_converthxs_uint(hxs) ((unsigned int)sat3_converthxs_int(hxs))


SAT_OBJECT sat3_createhxs_int(SAT_OBJECT where,int value)
{

    where=sat3_alloc(where,10+8);
	if(where==0) return 0;
	
	sat3_poke(where,SAT_DOHXS,5);
    sat3_poke(where+5,13,5);
	sat3_poke(where+10,value,8);

    return where;
}

// FIRST 32-BIT USED, DISCARD THE REST

int sat3_converthxs_int(SAT_OBJECT hxs)
{
unsigned size;
if(!hxs) return 0;
if(sat3_isptr(hxs)) hxs=sat3_peek(hxs,5);

if(sat3_peek(hxs,5)!=SAT_DOHXS) return 0;	// RETURN 0 IF NOT A HXS
size=sat3_peek(hxs+5,5-5);
if(size>8) size=8;

return sat3_peek(hxs+10,size);
}


// CREATE A 64-BIT HXS VALUE

#define sat3_createhxs_ullong(where,value) sat3_createhxs_llong(where,(LONGLONG)value)
#define sat3_converthxs_ullong(hxs) ((ULONGLONG)sat3_converthxs_llong(hxs))


SAT_OBJECT sat3_createhxs_llong(SAT_OBJECT where,LONGLONG value)
{

    where=sat3_alloc(where,10+16);
	if(where==0) return 0;
	
	sat3_poke(where,SAT_DOHXS,5);
    sat3_poke(where+5,21,5);
	sat3_poke(where+10,(unsigned int)value,8);
	sat3_poke(where+18,(unsigned int)(value>>32),8);
    return where;
}

// FIRST 64-BIT USED, DISCARD THE REST

LONGLONG sat3_converthxs_llong(SAT_OBJECT hxs)
{
unsigned size;
LONGLONG result;
if(!hxs) return 0;
if(sat3_isptr(hxs)) hxs=sat3_peek(hxs,5);

if(sat3_peek(hxs,5)!=SAT_DOHXS) return 0;	// RETURN 0 IF NOT A HXS
size=sat3_peek(hxs+5,5)-5;
if(size>16) size=16;
if(size>8) result=(((LONGLONG)sat3_peek(hxs+18,size-8))<<32)|sat3_peek(hxs+10,8);
else result=sat3_peek(hxs+10,size);
return result;
}



SAT_OBJECT sat3_createhxs_bytes(SAT_OBJECT where,char *data,int nbytes)
{

    where=sat3_alloc(where,10+2*nbytes);
	if(where==0) return 0;
	
	sat3_poke(where,SAT_DOHXS,5);
    sat3_poke(where+5,nbytes*2+5,5);
	int addr=where+10;
	
	while(nbytes--) { sat3_poke(addr,*data++,2); addr+=2; }

    return where;
}


BOOL sat3_converthxs_bytes(SAT_OBJECT cstr,char *data, int maxbytes)
{
int bytes;
if(!cstr) return 0;
if(sat3_isptr(cstr)) cstr=sat3_peek(cstr,5);

if(sat3_peek(cstr,5)!=SAT_DOHXS) return 0;	// RETURN 0 IF NOT A CSTR
bytes=(sat3_peek(cstr+5,5)-5+1);

if(bytes>(maxbytes<<1)) bytes=maxbytes<<1;

cstr+=10;
while(bytes>1) { bytes-=2; *data++=sat3_peek(cstr,2); cstr+=2; }
if(bytes) *data=sat3_peek(cstr,1);

return TRUE;
}



